// Nathan E. Moore
// April 8, 2004

#pragma once
#include "menuentry.h"
#include "../nem_utils/ls.h"
#include <string>
#include <stdexcept>
#include <windows.h>

class MenuBang : public MenuEntryBase
{
private:
	std::string m_bang;
	std::string m_args;

	MenuBang(const std::wstring& txt, const std::string& bcomd, const std::string& arguments)
		:MenuEntryBase(txt),
		m_bang(bcomd),
		m_args(arguments)
	{}

public:
	void execute(HWND hwnd)
	{
		if (!ParseBangCommand(hwnd, m_bang.c_str(), m_args.c_str()))
			throw std::runtime_error("ParseBangCommand Failed.");
	}

	bool displayContextMenu(HwndInterface&)
	{
		return false;
	}

	static MenuEntryPtr createMenuBang(const std::wstring& txt, const std::string& bcomd, const std::string& arguments)
	{
		MenuEntryPtr temp(new MenuBang(txt, bcomd, arguments));
		return temp;
	}
};
