// Nathan E. Moore
// April 8, 2004

#pragma once
#include "menuentry.h"
#include "idlist.h"
#include "globals.h"
#include <string>

class MenuItem : public MenuEntryBase
{
private:
	static bool s_hasextensions;
	std::wstring m_file;
	std::wstring m_args;

	// Only use with correct path, file name and arguments. Does no checking.
	MenuItem(const std::wstring& txt, const std::wstring& filename, const std::wstring& arguments)
		:MenuEntryBase(txt),
		m_file(filename),
		m_args(arguments)
	{}

	// Builds entry, file, and arguments from given commandline.
	MenuItem(const std::wstring& path, const std::wstring& arguments);

public:
	void execute(HWND hwnd);

	bool displayContextMenu(HwndInterface& hi)
	{
		return util::popupContextMenu(m_file, hi);
	}

	static MenuEntryPtr createMenuItem(const std::wstring& txt, const std::wstring& filename, const std::wstring& arguments)
	{
		MenuEntryPtr temp(new MenuItem(txt, filename, arguments));
		return temp;
	}

	static MenuEntryPtr createMenuItem(const std::wstring& path, const std::wstring& arguments)
	{
		MenuEntryPtr temp(new MenuItem(path, arguments));
		return temp;
	}

	static void enableExtensions(bool flag)
	{
		s_hasextensions = flag;
	}
};
