// Nathan E. Moore
// April 8, 2004

#pragma once
#include "menuentry.h"
#include <string>
#include <windows.h>

class MenuMessage : public MenuEntryBase
{
private:
	std::wstring m_windowclass;		// used to determine which window to send a message to.
	std::wstring m_windowtitle;		// used to detrermine which window to send a message to.
	UINT m_msg;						// message
	WPARAM m_wparam;				// first message parameter
	LPARAM m_lparam;				// second message parameter

	MenuMessage(const std::wstring& txt, const std::wstring& wndclass, const std::wstring& wndtitle, UINT message, WPARAM wparam, LPARAM lparam)
		:MenuEntryBase(txt),
		m_windowclass(wndclass),
		m_windowtitle(wndtitle),
		m_msg(message),
		m_wparam(wparam),
		m_lparam(lparam)
	{}

public:
	static MenuEntryPtr createMenuMessage(const std::wstring& txt, const std::wstring& wndclass, const std::wstring& wndtitle, UINT message, WPARAM wparam, LPARAM lparam)
	{
		MenuEntryPtr temp(new MenuMessage(txt, wndclass, wndtitle, message, wparam, lparam));
		return temp;
	}

	void execute(HWND)
	{
		const wchar_t* wclass = m_windowclass.empty() ? NULL : m_windowclass.c_str();
		const wchar_t* wtitle = m_windowtitle.empty() ? NULL : m_windowtitle.c_str();
		HWND msghwnd = FindWindow(wclass, wtitle);

		if (msghwnd != NULL)
			SendMessage(msghwnd, m_msg, m_wparam, m_lparam);
	}

	bool displayContextMenu(HwndInterface&)
	{
		return false;
	}
};
