// Nathan E. Moore
// April 3, 2003

#pragma once
#include "../nem_utils/lslog.h"
#include "../nem_utils/ls.h"
#include "../nem_utils/common.h"
#include <windows.h>
#include <boost/shared_array.hpp>
#include <boost/shared_ptr.hpp>

// these strings are macros because we need both Unicode and ANSI constants
#define MODULE_NAME_MACRO "Menu"
#define HOTLIST_MACRO "Litestep"

// there is no good way to tie these values to the Version info resource
// so if these get updated, update the version resource too.
// these could be read from the version info at load, or at every need
// but for the moment they're here.
static const wchar_t G_WMODULE_NAME[] = WSTR(MODULE_NAME_MACRO);
static const char G_MODULE_NAME[] = MODULE_NAME_MACRO;
static const char G_MODULE_VERSION[] = "0.81";

// Default entry / header values
static const wchar_t G_TASKS[] = L"Tasks";
static const char G_HOTLIST[] = HOTLIST_MACRO;
static const wchar_t G_WHOTLIST[] = WSTR(HOTLIST_MACRO);
static const wchar_t G_REMOTEAMP[] = L"Winamp Controls";

// iostream to LSLog
static lslog::LSLogStream g_log(G_MODULE_NAME, LOG_ERROR);
// this macro forces a call to LSLog() with each call
#define LSLOG(x) g_log << x << " " LOCATION << lslog::endmsg

// typedefs
// these are here to reduce the circular header depenencies
// To cast to one of these typedefs you should do
//		boost::static_pointer_cast<MenuEntryPtr::element_type>()
// as otherwise the typedefs are useless
class MenuEntryInterface;
typedef boost::shared_ptr<MenuEntryInterface> MenuEntryPtr;
class MenuSub;
typedef boost::shared_ptr<MenuSub> MenuSubPtr;

void getMonitorArea(POINT* pt, RECT* area) throw();
boost::shared_array<wchar_t> toUnicode(const char* astr);
boost::shared_array<wchar_t> toUnicodeNoThrow(const char* astr) throw();
