// Nathan E. Moore
// April 8, 2004

#pragma once
#include "menuentry.h"
#include <string>
#include <shtypes.h>
#include <shlobj.h>
#include <atlbase.h>
#include <atlcomcli.h>

namespace util
{
	class ItemIdList : public CComHeapPtr<ITEMIDLIST>
	{
	private:
		size_t sizeOf(ITEMIDLIST* pidl) const;
		ITEMIDLIST* file() const;

		ITEMIDLIST* next(ITEMIDLIST* pidl) const
		{
			return reinterpret_cast<ITEMIDLIST*>(reinterpret_cast<char*>(pidl) + pidl->mkid.cb);
		}

	public:
		ItemIdList()
			:CComHeapPtr<ITEMIDLIST>()
		{}

		explicit ItemIdList(ITEMIDLIST* pidl)
			:CComHeapPtr<ITEMIDLIST>(pidl)
		{}

		ItemIdList& append(const ItemIdList &idlist);
		ItemIdList getContainingElement() const;
		void execute(HWND hwnd);
		std::wstring getDisplayName() const;
		ItemIdList clone() const;

		ItemIdList& operator+=(const ItemIdList &idlist)
		{
			return append(idlist);
		}

		ItemIdList concat(const ItemIdList &idlist) const
		{
			// This could be rewriten to only do one alloc
			ItemIdList rval = clone();
			rval.append(idlist);
			return rval;
		}

		ItemIdList operator+(const ItemIdList& idlist) const
		{
			return concat(idlist);
		}
	};

	CComPtr<IShellFolder> getDesktop();
	bool popupContextMenu(const ItemIdList &idlist, HwndInterface& hi);
	bool popupContextMenu(const std::wstring &filesysobj, HwndInterface& hi);
	ItemIdList createVirtualFolder(int csidl);
}
